﻿' **** Minesweeper BASIC
' *** Written by Lukman Hakim
' *** March, 2009

Public Class gameForm

    Const MAINPIC_PADDING As Integer = 30
    Const LETTER_PADDING As Integer = 3

    Dim gameBoard As minesweeperBoard
    Dim bombBMP As Bitmap, brickTileBMP As Bitmap

    Dim gameOver As Boolean
    Dim level As Integer
    Dim elapsedSec As Long

    Private Sub drawBoard()
        Dim i As Integer, g As Graphics, b As Bitmap
        Dim row As Integer, col As Integer
        Dim operationalRect As Rectangle

        b = New Bitmap(640, 480)
        g = Graphics.FromImage(b)

        With gameBoard
            For i = 0 To .numOfMinePoint - 1

                col = (i Mod .maxCol)
                row = Math.Floor(i / .maxCol)

                operationalRect = New Rectangle(col * minesweeperPoint.MINEPOINT_WIDTH, _
                                                row * minesweeperPoint.MINEPOINT_HEIGHT, _
                                                minesweeperPoint.MINEPOINT_WIDTH, _
                                                minesweeperPoint.MINEPOINT_HEIGHT)

                If (.minePoint(i).opened) Then

                    If (.minePoint(i).isBomb) Then

                        If .minePoint(i).flagStatus = minesweeperPoint.flag.HITTED Then
                            g.FillRectangle(New SolidBrush(Color.Red), operationalRect)
                        End If

                        g.DrawImageUnscaled(bombBMP, operationalRect)

                        ' *** draw mine
                    ElseIf (.minePoint(i).mineAround = 0) Then
                        ' *** draw nothing
                    Else
                        g.DrawString(.minePoint(i).mineAround.ToString, _
                                     New Font("Arial", 14), _
                                     New SolidBrush(minesweeperPoint.LETTER_COLOR(.minePoint(i).mineAround)), _
                                     col * minesweeperPoint.MINEPOINT_WIDTH + LETTER_PADDING, _
                                     row * minesweeperPoint.MINEPOINT_HEIGHT + LETTER_PADDING)

                        If .minePoint(i).flagStatus = minesweeperPoint.flag.FLAGGED Then
                            g.DrawString("X", _
                                    New Font("arial", 14, FontStyle.Bold, GraphicsUnit.Point), _
                                     New SolidBrush(Color.FromArgb(255, 255, 0, 0)), _
                                     col * minesweeperPoint.MINEPOINT_WIDTH + LETTER_PADDING, _
                                     row * minesweeperPoint.MINEPOINT_HEIGHT + LETTER_PADDING)

                        End If

                    End If

                    g.DrawRectangle(New Pen(Color.FromArgb(128, 128, 128, 128), 2), operationalRect)

                Else

                    g.DrawImageUnscaled(brickTileBMP, operationalRect.X, operationalRect.Y)

                    Select Case .minePoint(i).flagStatus

                        Case minesweeperPoint.flag.FLAGGED
                            g.DrawString("X", New Font("Arial", 12, FontStyle.Bold), _
                                         New SolidBrush(Color.Red), _
                                         col * minesweeperPoint.MINEPOINT_WIDTH + LETTER_PADDING + 2, _
                                         row * minesweeperPoint.MINEPOINT_HEIGHT + LETTER_PADDING)

                        Case minesweeperPoint.flag.QUESTIONED
                            g.DrawString("?", New Font("Arial", 12, FontStyle.Bold), _
                                         New SolidBrush(Color.Blue), _
                                         col * minesweeperPoint.MINEPOINT_WIDTH + LETTER_PADDING + 2, _
                                         row * minesweeperPoint.MINEPOINT_HEIGHT + LETTER_PADDING)
                    End Select

                End If
            Next

        End With

        mainPicBox.Image = b.Clone
        g.Dispose()

    End Sub


    Private Sub point_clicked(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles mainPicBox.MouseDown
        Dim buttonIndex As Integer
        Dim col As Integer, row As Integer
        Dim status As Integer

        If (gameOver) Then Exit Sub

        col = Math.Floor(e.X / minesweeperPoint.MINEPOINT_WIDTH)
        row = Math.Floor(e.Y / minesweeperPoint.MINEPOINT_HEIGHT)
        buttonIndex = row * gameBoard.maxCol + col

        If (gameBoard.minePoint(buttonIndex).opened) Then Exit Sub

        Select Case e.Button

            Case Windows.Forms.MouseButtons.Left

                status = gameBoard.openMinePoint(buttonIndex)

                Select Case status
                    Case minesweeperBoard.gameStatus.LOSE
                        gameOver = True
                        countTimer.Enabled = False

                    Case minesweeperBoard.gameStatus.WIN
                        gameOver = True
                        countTimer.Enabled = False
                        MsgBox("Congratulation. You win!", MsgBoxStyle.Information, "Win")

                End Select

            Case Windows.Forms.MouseButtons.Right

                With gameBoard.minePoint(buttonIndex)

                    Select Case .flagStatus

                        Case minesweeperPoint.flag.NONE
                            .flagStatus = minesweeperPoint.flag.FLAGGED

                        Case minesweeperPoint.flag.FLAGGED
                            .flagStatus = minesweeperPoint.flag.QUESTIONED

                        Case Else
                            .flagStatus = minesweeperPoint.flag.NONE

                    End Select

                End With


            Case Windows.Forms.MouseButtons.Middle

                ' **** middle click => RESERVED

        End Select

        Call drawBoard()

        bombLbl.Text = "Mines left: " & gameBoard.getBombNumberAssumption().ToString

    End Sub

    Private Sub initializeGame()

        gameBoard = New minesweeperBoard(level)

        Me.Size = New Size(gameBoard.boardSize.Width + (3 * MAINPIC_PADDING), _
                           gameBoard.boardSize.Height + (4 * MAINPIC_PADDING))

        mainPicBox.Size = New Size(gameBoard.boardSize.Width, gameBoard.boardSize.Height)
        mainPicBox.Location = New Point(MAINPIC_PADDING, MAINPIC_PADDING)

        resetBtn.Left = mainPicBox.Right - resetBtn.Width
        levelCombo.Left = mainPicBox.Left
        bombLbl.Left = mainPicBox.Left
        bombLbl.Top = mainPicBox.Top + mainPicBox.Height + 5
        timeLbl.Left = bombLbl.Left
        timeLbl.Top = bombLbl.Top + bombLbl.Height + 3
        gameOver = False

        Call drawBoard()

        bombLbl.Text = "Mines left: " & gameBoard.getBombNumberAssumption().ToString

        elapsedSec = 0
        countTimer.Enabled = True

    End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        level = minesweeperBoard.level.MEDIUM
        levelCombo.SelectedIndex = 1

        bombBMP = minesweeperPoint.drawBomb().Clone
        brickTileBMP = minesweeperPoint.drawTile().Clone

        Call initializeGame()


    End Sub

    Private Sub resetBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles resetBtn.Click

        gameBoard = Nothing

        Call initializeGame()

    End Sub

    Private Sub levelCombo_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles levelCombo.SelectedIndexChanged

        Select Case levelCombo.SelectedIndex
            Case 0
                level = minesweeperBoard.level.EASY
            Case 1
                level = minesweeperBoard.level.MEDIUM
            Case 2
                level = minesweeperBoard.level.EXPERT
        End Select

    End Sub

    Private Sub countTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles countTimer.Tick
        elapsedSec = elapsedSec + 1
        timeLbl.Text = "Elapsed time: " & elapsedSec.ToString & " s"
    End Sub
End Class



